local RC = LibStub("AceAddon-3.0"):GetAddon("Raid Check")
local L = LibStub("AceLocale-3.0"):GetLocale("Raid Check", true)

-- Player Data Array is currently composed of: Name, Realm, hasFlask, hasFood, hasRune, Class, Role, hasVantusRune
RC.playerData = {};

RC.AddOn_Name = "Raid Check";

RC.MainFrameWidth = 325;

RC.GrpWidth = RC.MainFrameWidth-5;
RC.DDWidth = 100;

RC.ButtonWidth = 85;
RC.ButtonHeight = 25;

RC.PlayerWidth	= 115;
RC.FlFoRuWidth	= 40;
RC.SpellWidth	= 80;
RC.Spacing = 5;

-- UI Height Slider Variables
RC.UserScreenResolution = ({GetScreenResolutions()})[GetCurrentResolution()];
if RC.UserScreenResolution then
	RC.MaxWidth, RC.MaxHeight = RC.UserScreenResolution:match("([^,]+)x([^,]+)")
else
	RC.MaxWidth = 325
	RC.MaxHeight = 800
end
RC.MinHeight = 240;
RC.SliderStep = 10;

RC.GBoW = 203539; -- Retribution Paladin's Greater Blessing of Wisdom

-- Food Levels will change after hitting 60 on live, will remove BFA at SL launch
RC.FoodLevels = {
	30,
	20,
	19,
	18,
};

RC.Food = {
	327706, -- SL Strength 20
	327707, -- SL Stamina 30 (20)
	327708, -- SL Intellect 20
	327709, -- SL Agility 20

	327701, -- SL Strength 18
	327702, -- SL Stamina 27 (18)
	327704, -- SL Intellect 18
	327705, -- SL Agility 18

	308525, -- SL Stam 22
	308520, -- SL Stam 14

	308434, -- SL Crit 30
	308488, -- SL Haste 30
	308506, -- SL Mastery 30
	308514, -- SL Versatility 30

	308430, -- SL Crit 18
	308474, -- SL Haste 18
	308504, -- SL Mastery 18
	308509, -- SL Versatility 18

};

RC.FlaskLevels = {
	70, -- SL Flask of Power
	38,	-- BfA Flasks
};

RC.Flask = {
	307185, --SL Spectral Flask of Power (Agility Intellect Strength)
	307187, --SL Spectral Flask of Stamina
	307166, --

	298836, --BFA Agility
	298837, --BFA Intellect
	298839, --BFA Stamina
	298841, --BFA Strength
};

RC.RuneLevels = {
	18, --Veiled Augment Rune
	6, --BfA Rune
};

RC.Runes = {
	347901, --Veiled Augment Rune
	317065, --Lightning rune
	270058,	--Battle-Scarred Augmentation
};

RC.FelFocus = 242551; --Fel Focus 7.2

--Vantus Rune Checking
RC.VantusRuneCheckEnabled = false  -- Global variable to assist in checking for Vantus Rune buffs only when we are at the selected Boss

--These are set as sub tables because when we check for a Spell we are using a table, in this way we only need to provide the selected SpellID that corresponds to the selected Vantus Rune to check
RC.VantusSpellIds = {
	{0},
	{313556}, -- N/Zoth
	{334131}, -- Sire Denathrius
	{354384}, -- The Tarragrue
	{354385}, -- The Eye of the Jailer
	{354386}, -- The Nine
	{354387}, -- Remnant of Ner'zhul
	{354388}, -- Soulrender Dormazain
	{354389}, -- Painsmith Raznal
	{354390}, -- Guardian of the First Ones
	{354391}, -- Fatescribe Roh-Kalo
	{354392}, -- Kel'Thuzad
	{354393}, -- Sylvanas Windrunner
};

--Since some of the fights are Council fights, then we need to utilize sub-tables for consistency, it also appears that there are multiple IDs?
RC.VantusBossIds = {
	{0},
	{158041}, -- N'Zoth
	{167406}, -- Sire Denathrius
	{163538}, -- The Tarragrue
	{175725}, -- The Eye of the Jailer
	{178738,177094,178684}, -- The Nine
	{175729}, -- Remnant of Ner'zhul
	{175727}, -- Soulrender Dormazain
	{176523}, -- Painsmith Raznal
	{175731}, -- Guardian of the First Ones
	{175730}, -- Fatescribe Roh-Kalo
	{175559}, -- Kel'Thuzad
	{175732}, -- Sylvanas Windrunner
};

-- In Game if you run the following, it gives you the list of all Encounter IDs, we are going to use this to find the proper IDs to populate the Encounter Names.
-- The script is from WowInterface user Ketho:  http://www.wowinterface.com/forums/showthread.php?t=53806
-- /run local i=1 while EJ_GetInstanceByIndex(i,true)do local a1,a2=EJ_GetInstanceByIndex(i,true)print(a1,a2)EJ_SelectInstance(a1)i=i+1 local j=1 while EJ_GetEncounterInfoByIndex(j,a1)do local b1,_,b2=EJ_GetEncounterInfoByIndex(j,a1)print(b2,b1)j=j+1 end end
RC.EncounterIds = {
	2375, --N'Zoth
	2424, -- Sire Denathrius
	2435, -- The Tarragrue
	2442, -- The Eye of the Jailer
	2439, -- The Nine
	2444, -- Remnant of Ner'zhul
	2445, -- Soulrender Dormazain
	2443, -- Painsmith Raznal
	2446, -- Guardian of the First Ones
	2447, -- Fatescribe Roh-Kalo
	2440, -- Kel'Thuzad
	2441, -- Sylvanas Windrunner
};

--We want this to be a localized list, so we populate all the Boss Names when the Settings tab is opened, we use the Encounter IDs
RC.VantusBossNames = {
	L["none"],
};


--The following are override values for items that may not give the exact number appropriately
--[[RC.OverRide17 = 225606; -- Fishbrul Special (17)

RC.OverRide75 = {
	201637, -- Feast Stamina 27 (18)
	201636, -- Feast Intellect 18
	201635, -- Feast Agility 18
	201634, -- Feast Strength 18

};

RC.OverRide100 = {
	201641, -- Feast Stamina 34 (22)
	201640, -- Feast Intellect 22
	201639, -- Feast Agility 22
	201638, -- Feast Strength 22
};--]]


-- These are the primary stat buffs, we will also use these to create labels in the UI to include the Name used as I think the name retruned from GetSpellInfo is localized
-- If I set these to true, then as I'm going through the group if anyone doesn't have it then I can set it to false it will only be green if everyone in the group has the buff
RC.PrimaryStatBuffs = {
	{1459, true},	--Arcane Intellect
	{6673, true},	--Battle Shout
	{21562, true},	--Power Word Fortitude
};

-- Currently anything more complex than this is kind of pointless
-- 1:Warrior	2:Paladin	3:Hunter	4:Rogue	5:Priest	6:Death Knight	7:Shaman	8:Mage	9:Warlock	10:Monk	11:Druid	12:Demon Hunter
RC.ClassInGroup = {};
for i = 1, GetNumClasses() do
	RC.ClassInGroup[i] = false;
end

RC.Warriors	= "";
RC.Paladins	= "";
RC.Hunters	= "";
RC.Priests	= "";
RC.DKs		= "";
RC.Shamans	= "";
RC.Mages	= "";
RC.Warlocks	= "";
RC.Monks	= "";
RC.Druids	= "";
RC.DHs		= "";
